#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

#define CONTAINER_OF(ptr, type, field) \
	((type *)((unsigned long)(ptr) - (unsigned long)(&((type *)(0))->field)))

struct slist_node {
	struct slist_node *next;
};

struct my_struct {
	char		       *data;
	struct slist_node	list;
};

struct slist_node *
slist_add(struct slist_node *head, struct slist_node *node)
{
	if (head != NULL) {
		node->next = head;
		head = node;
	} else {
		node->next = NULL;
		head = node;
	}

	return head;
}

struct slist_node *
slist_reverse(struct slist_node *head)
{
	struct slist_node *iter, *next, *new_list;

	new_list = NULL;

	for (iter = head; iter != NULL; iter = next) {
		next = iter->next;
		iter->next = new_list; 
		new_list = iter;
	}

	return new_list;
}

int
main(int argc, char *argv[])
{
	struct my_struct a, b, c, *up;
	struct slist_node *hp, *iter;

	hp     = NULL;
	a.data = "a";
	b.data = "b";
	c.data = "c";

	hp = slist_add(hp, &a.list);
	hp = slist_add(hp, &b.list);
	hp = slist_add(hp, &c.list);

	hp = slist_reverse(hp);

	for (iter = hp; iter != NULL; iter = iter->next) {
		up = CONTAINER_OF(iter, struct my_struct, list);
		
		printf("My data: %s\n", up->data);
	}

	return 0;
}

